## videorate videorate — Drops/duplicates/adjusts timestamps on video frames to make a perfect stream |

## Properties

guint64 | drop | Read
guint64 | duplicate | Read
guint64 | in | Read
gdouble | new-pref | Read / Write
guint64 | out | Read
gboolean | silent | Read / Write
gboolean | skip-to-first | Read / Write
guint64 | average-period | Read / Write
gboolean | drop-only | Read / Write
gint | max-rate | Read / Write / Construct

## Types and Values

struct | GstVideoRate

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBaseTransform
                        ╰── GstVideoRate

## Description

This element takes an incoming stream of timestamped video frames. It will produce a perfect stream that matches the source pad's framerate.

The correction is performed by dropping and duplicating frames, no fancy algorithm is used to interpolate frames (yet).

By default the element will simply negotiate the same framerate on its source and sink pad.

This operation is useful to link to elements that require a perfect stream. Typical examples are formats that do not store timestamps for video frames, but only store a framerate, like Ogg and AVI.

A conversion to a specific framerate can be forced by using filtered caps on the source pad.

The properties “in”, “out”, “duplicate” and “drop” can be read to obtain information about number of input frames, output frames, dropped frames (i.e. the number of unused input frames) and duplicated frames (i.e. the number of times an input frame was duplicated, beside being used normally).

An input stream that needs no adjustments will thus never have dropped or duplicated frames.

When the “silent” property is set to FALSE, a GObject property notification will be emitted whenever one of the “duplicate” or “drop” values changes. This can potentially cause performance degradation. Note that property notification will happen from the streaming thread, so applications should be prepared for this.

### Example pipelines

    1
    gst-launch -v filesrc location=videotestsrc.ogg ! oggdemux ! theoradec ! videorate ! video/x-raw,framerate=15/1 ! xvimagesink

Decode an Ogg/Theora file and adjust the framerate to 15 fps before playing. To create the test Ogg/Theora file refer to the documentation of theoraenc.

    1
    gst-launch -v v4l2src ! videorate ! video/x-raw,framerate=25/2 ! theoraenc ! oggmux ! filesink location=recording.ogg

Capture video from a V4L device, and adjust the stream to 12.5 fps before encoding to Ogg/Theora.

Last reviewed on 2006-09-02 (0.10.11)

## Synopsis

### Element Information

plugin | videorate
author | Wim Taymans <wim@fluendo.com>
class | Filter/Effect/Video

### Element Pads

name | sink
direction | sink
presence | always
details | video/x-raw
| image/jpeg
| image/png

name | src
direction | source
presence | always
details | video/x-raw
| image/jpeg
| image/png

## Functions

## Types and Values

### struct GstVideoRate

    struct GstVideoRate;

Opaque data structure.

## Property Details

### The `“drop”` property

      “drop”                     guint64

Number of dropped frames.

Flags: Read

Default value: 0

### The `“duplicate”` property

      “duplicate”                guint64

Number of duplicated frames.

Flags: Read

Default value: 0

### The `“in”` property

      “in”                       guint64

Number of input frames.

Flags: Read

Default value: 0

### The `“new-pref”` property

      “new-pref”                 gdouble

Value indicating how much to prefer new frames (unused).

Flags: Read / Write

Allowed values: [0,1]

Default value: 1

### The `“out”` property

      “out”                      guint64

Number of output frames.

Flags: Read

Default value: 0

### The `“silent”` property

      “silent”                   gboolean

Don't emit notify for dropped and duplicated frames.

Flags: Read / Write

Default value: TRUE

### The `“skip-to-first”` property

      “skip-to-first”            gboolean

Don't produce buffers before the first one we receive.

Flags: Read / Write

Default value: FALSE

Since 0.10.25

### The `“average-period”` property

      “average-period”           guint64

Arrange for maximum framerate by dropping frames beyond a certain framerate, where the framerate is calculated using a moving average over the configured.

Flags: Read / Write

Allowed values: <= G_MAXLONG

Default value: 0

Since 0.10.36

### The `“drop-only”` property

      “drop-only”                gboolean

Only drop frames, no duplicates are produced.

Flags: Read / Write

Default value: FALSE

Since 0.10.36

### The `“max-rate”` property

      “max-rate”                 gint

maximum framerate to pass through

Flags: Read / Write / Construct

Allowed values: >= 1

Default value: 2147483647

Since 0.10.36